/* -------------------------------------------- */
import { MournbladeCYD2Combat } from "./mournblade-cyd2-combat.js";
import { MournbladeCYD2Commands } from "./mournblade-cyd2-commands.js";

/* -------------------------------------------- */
const __distanceDifficulte = { "porteecourte": 5, "porteemoyenne": 9, "porteelongue": 14 }
const __tireurDeplacement = { immobile: 0, lent: 3, rapide: 5 }
const __cibleCouvert = { aucun: 0, leger: 5, complet: 10 }
const __tailleCible = { normal: 0, main: 10, enfant: 3, maison: -10 }

/* -------------------------------------------- */
export class MournbladeCYD2Utility {


  /* -------------------------------------------- */
  static async init() {
    Hooks.on('renderChatLog', (log, html, data) => MournbladeCYD2Utility.chatListeners(html))
    Hooks.on("getChatMessageContextOptions", (html, options) => MournbladeCYD2Utility.chatRollMenu(html, options))
    Hooks.on("getCombatTrackerEntryContext", (html, options) => {
      MournbladeCYD2Utility.pushInitiativeOptions(html, options);
    })

    this.rollDataStore = {}
    this.defenderStore = {}
    MournbladeCYD2Commands.init()

    Handlebars.registerHelper('count', function (list) {
      return list.length;
    })
    Handlebars.registerHelper('includes', function (array, val) {
      return array.includes(val);
    })
    Handlebars.registerHelper('upper', function (text) {
      return text.toUpperCase();
    })
    Handlebars.registerHelper('lower', function (text) {
      return text.toLowerCase()
    })
    Handlebars.registerHelper('upperFirst', function (text) {
      if (typeof text !== 'string') return text
      return text.charAt(0).toUpperCase() + text.slice(1)
    })
    Handlebars.registerHelper('notEmpty', function (list) {
      return list.length > 0;
    })
    Handlebars.registerHelper('mul', function (a, b) {
      return parseInt(a) * parseInt(b);
    })

    game.settings.register("fvtt-mournblade-cyd2", "mournblade-cyd2-pause-logo", {
      name: "Logo de pause",
      scope: "world",
      config: true,
      requiresReload: true,
      default: "mournblade_logo_chaos",
      type: String,
      choices: {           // If choices are defined, the resulting setting will be a select menu
        "mournblade_logo_chaos": "Mournblade (Chaos)",
        "mournblade_logo_texte": "Mournblade (Texte)",
        "mournblade-cyd2_logo": "MournbladeCYD2 (Texte)",
        "logo_pause_resistance": "Résistance",
        "logo_pause_mournblade-cyd2_stone": "MournbladeCYD2 (Pierre)",
        "logo_pause_mournblade-cyd2_violet": "MournbladeCYD2 (Violet)",
        "logo_pause_mournblade-cyd2_beige": "MournbladeCYD2 (Beige)",
        "logo_pause_mournblade-cyd2_rouge": "MournbladeCYD2 (Rouge)"
      },
    })

  }

  /* -------------------------------------------- */
  static sortArrayObjectsByName(myArray) {
    myArray.sort((a, b) => {
      return a.name.localeCompare(b.name);
    })
  }

  /* -------------------------------------------- */
  static getModificateurOptions() {
    let opt = []
    for (let i = -15; i <= 15; i++) {
      opt.push(`<option value="${i}">${i}</option>`)
    }
    return opt.concat("\n")
  }

  /* -------------------------------------------- */
  static getPointAmeOptions() {
    let opt = []
    for (let i = 1; i <= 20; i++) {
      opt.push(`<option value="${i}">${i}</option>`)
    }
    return opt.concat("\n")
  }

  /* -------------------------------------------- */
  static getAttributs() {
    return { adr: "Adresse", pui: "Puissance", cla: "Clairvoyance", pre: "Présence", tre: "Trempe" }
  }
  /* -------------------------------------------- */
  static pushInitiativeOptions(html, options) {
  }

  /* -------------------------------------------- */
  static getSkills() {
    return this.skills
  }

  /* -------------------------------------------- */
  static async ready() {
    const skills = await MournbladeCYD2Utility.loadCompendium("fvtt-mournblade-cyd2.skills")
    this.skills = skills.map(i => i.toObject())

    // Setup pause logo
    let logoPause = "systems/fvtt-mournblade-cyd2/assets/logos/" + game.settings.get("fvtt-mournblade-cyd2", "mournblade-cyd2-pause-logo") + ".webp"
    let logoImg = document.querySelector('#pause').children[0]
    logoImg.setAttribute('style', `content: url(${logoPause})`)

    game.system.mournbladecyd2.config.listeNiveauSkill = this.createDirectOptionList(0, 10)
    game.system.mournbladecyd2.config.listeNiveauCreature = this.createDirectOptionList(0, 35)
    game.system.mournbladecyd2.config.listeNiveauContact = this.createDirectOptionList(1, 3)
  }

  /* -------------------------------------------- */
  static createDirectOptionList(min, max) {
    let options = {};
    for (let i = min; i <= max; i++) {
      options[`${i}`] = `${i}`;
    }
    return options;
  }
  static createArrayOptionList(min, max) {
    let options = [];
    for (let i = min; i <= max; i++) {
      options.push({ key: `${i}`, label: `${i}` });
    }
    return options;
  }

  /* -------------------------------------------- */
  static async loadCompendiumData(compendium) {
    const pack = game.packs.get(compendium);
    return await pack?.getDocuments() ?? [];
  }

  /* -------------------------------------------- */
  static async loadCompendium(compendium, filter = item => true) {
    let compendiumData = await MournbladeCYD2Utility.loadCompendiumData(compendium);
    return compendiumData.filter(filter);
  }

  /* -------------------------------------------- */
  static getOptionsStatusList() {
    return this.optionsStatusList;
  }
  /* -------------------------------------------- */
  static async chatListeners(html) {

    $(html).on("click", '.predilection-reroll', async event => {
      let predIdx = $(event.currentTarget).data("predilection-index")
      let messageId = MournbladeCYD2Utility.findChatMessageId(event.currentTarget)
      let message = game.messages.get(messageId)
      let rollData = message.getFlag("world", "mournblade-cyd2-roll")
      let actor = MournbladeCYD2Utility.getActorFromRollData(rollData)
      await actor.setPredilectionUsed(rollData.competence._id, predIdx)
      rollData.competence = foundry.utils.duplicate(actor.getCompetence(rollData.competence._id))
      MournbladeCYD2Utility.rollMournbladeCYD2(rollData)
    })

    $(html).on("click", '.roll-chat-degat', async event => {
      let messageId = MournbladeCYD2Utility.findChatMessageId(event.currentTarget)
      let message = game.messages.get(messageId)
      let rollData = message.getFlag("world", "mournblade-cyd2-roll")
      let actor = MournbladeCYD2Utility.getActorFromRollData(rollData)
      actor.rollArmeDegats(rollData.arme._id, rollData.targetVigueur, rollData)
    })
    $(html).on("click", '.roll-chat-degat-devastateur', async event => {
      let messageId = MournbladeCYD2Utility.findChatMessageId(event.currentTarget)
      let message = game.messages.get(messageId)
      let rollData = message.getFlag("world", "mournblade-cyd2-roll")
      let actor = MournbladeCYD2Utility.getActorFromRollData(rollData)
      rollData.applyCoupDevastateur = true
      actor.rollArmeDegats(rollData.arme._id, rollData.targetVigueur, rollData)
    })

  }

  /* -------------------------------------------- */
  static async preloadHandlebarsTemplates() {

    const templatePaths = [
      'systems/fvtt-mournblade-cyd2/templates/editor-notes-gm.html',
      'systems/fvtt-mournblade-cyd2/templates/partial-item-header.html',
      'systems/fvtt-mournblade-cyd2/templates/partial-item-description.html',
      'systems/fvtt-mournblade-cyd2/templates/partial-item-nav.html',
      'systems/fvtt-mournblade-cyd2/templates/partial-item-prix.html',
      'systems/fvtt-mournblade-cyd2/templates/partial-automation.html',
      'systems/fvtt-mournblade-cyd2/templates/hud-adversites.html',
    ]
    return foundry.applications.handlebars.loadTemplates(templatePaths);
  }

  /* -------------------------------------------- */
  static removeChatMessageId(messageId) {
    if (messageId) {
      game.messages.get(messageId)?.delete();
    }
  }

  static findChatMessageId(current) {
    return MournbladeCYD2Utility.getChatMessageId(MournbladeCYD2Utility.findChatMessage(current));
  }

  static getChatMessageId(node) {
    return node?.attributes.getNamedItem('data-message-id')?.value;
  }

  static findChatMessage(current) {
    return MournbladeCYD2Utility.findNodeMatching(current, it => it.classList.contains('chat-message') && it.attributes.getNamedItem('data-message-id'))
  }

  static findNodeMatching(current, predicate) {
    if (current) {
      if (predicate(current)) {
        return current;
      }
      return MournbladeCYD2Utility.findNodeMatching(current.parentElement, predicate);
    }
    return undefined;
  }

  /* -------------------------------------------- */
  static createDirectOptionList(min, max) {
    let options = {};
    for (let i = min; i <= max; i++) {
      options[`${i}`] = `${i}`;
    }
    return options;
  }

  /* -------------------------------------------- */
  static buildListOptions(min, max) {
    let options = ""
    for (let i = min; i <= max; i++) {
      options += `<option value="${i}">${i}</option>`
    }
    return options;
  }

  /* -------------------------------------------- */
  static getTarget() {
    if (game.user.targets && game.user.targets.size == 1) {
      for (let target of game.user.targets) {
        return target;
      }
    }
    return undefined;
  }

  /* -------------------------------------------- */
  static getActorFromRollData(rollData) {
    let actor = game.actors.get(rollData.actorId)
    if (rollData.tokenId) {
      let token = canvas.tokens.placeables.find(t => t.id == rollData.tokenId)
      if (token) {
        actor = token.actor
      }
    }
    return actor
  }

  /* -------------------------------------------- */
  static updateRollData(rollData) {

    let id = rollData.rollId;
    let oldRollData = this.rollDataStore[id] || {};
    let newRollData = foundry.utils.mergeObject(oldRollData, rollData);
    this.rollDataStore[id] = newRollData;
  }

  /* -------------------------------------------- */
  static onSocketMesssage(msg) {
    if (msg.msg == "msg_apply_combativite") {
      let defender = game.canvas.tokens.get(msg.data.defenderTokenId)?.actor
      if (defender) {
        defender.changeEtatCombativite(msg.data.value)
      } else {
        console.warn("MournbladeCYD2Utility.onSocketMesssage : Impossible de trouver le token pour appliquer la combativité", msg.defenderTokenId)
      }
    }
  }

  /* -------------------------------------------- */
  static chatDataSetup(content, modeOverride, isRoll = false, forceWhisper) {
    let chatData = {
      user: game.user.id,
      rollMode: modeOverride || game.settings.get("core", "rollMode"),
      content: content
    };

    if (["gmroll", "blindroll"].includes(chatData.rollMode)) chatData["whisper"] = ChatMessage.getWhisperRecipients("GM").map(u => u.id);
    if (chatData.rollMode === "blindroll") chatData["blind"] = true;
    else if (chatData.rollMode === "selfroll") chatData["whisper"] = [game.user];

    if (forceWhisper) { // Final force !
      chatData["speaker"] = ChatMessage.getSpeaker();
      chatData["whisper"] = ChatMessage.getWhisperRecipients(forceWhisper);
    }

    return chatData;
  }

  /* -------------------------------------------- */
  static async showDiceSoNice(roll, rollMode) {
    if (game.modules.get("dice-so-nice")?.active) {
      if (game.dice3d) {
        let whisper = null;
        let blind = false;
        rollMode = rollMode ?? game.settings.get("core", "rollMode");
        switch (rollMode) {
          case "blindroll": //GM only
            blind = true;
          case "gmroll": // GM + rolling player
            whisper = this.getUsers(user => user.isGM);
            break;
          case "roll": // everybody
            whisper = this.getUsers(user => user.active);
            break;
          case "selfroll":
            whisper = [game.user.id];
            break;
        }
        await game.dice3d.showForRoll(roll, game.user, true, whisper, blind);
      }
    }
  }

  /* -------------------------------------------- */
  static computeMonnaieDetails(valueSC) {
    let po = Math.floor(valueSC / 400)
    let pa = Math.floor((valueSC - (po * 400)) / 20)
    let sc = valueSC - (po * 400) - (pa * 20)
    return {
      po, pa, sc, valueSC
    }
  }

  /* -------------------------------------------- */
  static computeResult(rollData) {
    rollData.diceResult = rollData.roll.terms[0].results[0].result
    if (rollData.mainDice.includes("d20")) {
      let diceValue = rollData.roll.terms[0].results[0].result
      if (diceValue % 2 == 1) {
        //console.log("PAIR/IMP2", diceValue)
        rollData.finalResult -= rollData.roll.terms[0].results[0].result // Substract value
        if (diceValue == 1 || diceValue == 11) {
          rollData.isDramatique = true
          rollData.isSuccess = false
        }
      }
    }

    //console.log("Result : ", rollData
    this.computeResultQuality(rollData)
  }

  /* -------------------------------------------- */
  static computeResultQuality(rollData) {
    if (rollData.difficulte > 0 && !rollData.isDramatique) {
      rollData.isSuccess = (rollData.finalResult >= rollData.difficulte)
      rollData.isHeroique = ((rollData.finalResult - rollData.difficulte) >= 10)
      rollData.isDramatique = ((rollData.finalResult - rollData.difficulte) <= -10)
    }
  }

  /* -------------------------------------------- */
  static applyCombativite(rollData, value) {
    if (game.user.isGM) {
      let defender = game.canvas.tokens.get(rollData.defenderTokenId).actor
      defender.changeEtatCombativite(value)
    } else {
      game.socket.emit("system.fvtt-mournblade-cyd2", { msg: "msg_apply_combativite", data: { defenderTokenId: rollData.defenderTokenId, value } });
    }
  }
  /* -------------------------------------------- */
  static async rollMournbladeCYD2(rollData) {

    let actor = this.getActorFromRollData(rollData)
    if (rollData.attrKey == "tochoose") { // No attr selected, force address
      rollData.attrKey = "adr"
    }
    if (!rollData.attr) {
      rollData.actionImg = "systems/fvtt-mournblade-cyd2/assets/icons/" + actor.system.attributs[rollData.attrKey].labelnorm + ".webp"
      rollData.attr = foundry.utils.duplicate(actor.system.attributs[rollData.attrKey])
    }
    if (rollData.attrKey2 != "none") {
      rollData.attr2 = foundry.utils.duplicate(actor.system.attributs[rollData.attrKey2])
    }

    if (rollData.maitriseId != "none") {
      rollData.selectedMaitrise = rollData.maitrises.find(p => p.id == rollData.maitriseId)
      rollData.diceFormula = "2" + rollData.mainDice + "kh"
    } else {
      rollData.diceFormula = "1" + rollData.mainDice
    }

    //console.log("BEFORE COMP", rollData)
    if (rollData.competence) {
      rollData.predilections = foundry.utils.duplicate(rollData.competence.system.predilections || [])
      let compmod = (rollData.competence.system.niveau == 0) ? -3 : 0
      rollData.diceFormula += `+${rollData.attr.value}+${rollData.competence.system.niveau}+${rollData.modificateur}+${compmod}`

      if (rollData.selectedTalents && rollData.selectedTalents.length > 0) {
        for (let id of rollData.selectedTalents) {
          let talent = rollData.talents.find(t => t._id == id)
          let bonusOK = true
          if (talent.system.baCost) {
            bonusOK = actor.checkBonneAventure(talent.system.baCost)
            if (bonusOK) {
              actor.changeBonneAventure(-talent.system.baCost)
            } else {
              ui.notifications.warn("Vous n'avez pas assez de points de Bonne Aventure !")
            }
          }
          if (bonusOK) {
            rollData.diceFormula += `+${talent.system.bonus}`
          }
        }
      }
      rollData.diceFormula += `+${rollData.bonusMalusContext}`
    } else if (rollData.attr2) {
      rollData.diceFormula += `+${rollData.attr.value}+${rollData.attr2.value}+${rollData.modificateur}+${rollData.bonusMalusContext}`
    } else {
      rollData.diceFormula += `+${rollData.attr.value}*${rollData.multiplier}+${rollData.modificateur}+${rollData.bonusMalusContext}`
    }

    // Bonus arme naturelle en défense
    if (rollData.bonusArmeNaturelle) {
      rollData.diceFormula += `+${rollData.bonusArmeNaturelle}`
    }
    if (rollData.attaquantsMultiples) {
      rollData.diceFormula += `+3`
    }
    if (rollData.hasAmbidextre) {
      if (rollData.ambidextre1) {
        rollData.diceFormula += `-3`
      } else if (rollData.ambidextre2) {
        rollData.diceFormula += `-6`
      }
    }
    if (rollData.defenseurAuSol) {
      rollData.diceFormula += `+3`
    }
    if (rollData.defenseurAveugle) {
      rollData.diceFormula += `+10`
    }
    if (rollData.defenseurDeDos) {
      rollData.diceFormula += `+5`
    }
    if (rollData.defenseurRestreint) {
      rollData.diceFormula += `+3`
    }
    if (rollData.defenseurImmobilise) {
      rollData.diceFormula += `+5`
    }
    if (rollData.soutiens > 0) { // 1 soutien = +3, 2 soutiens = +4, 3 soutiens = +5
      rollData.diceFormula += `+${rollData.soutiens + 2}`
    }

    if (rollData.arme?.system.isDistance) {
      rollData.difficulte = __distanceDifficulte[rollData.distanceTir]
      rollData.difficulte += __tireurDeplacement[rollData.tireurDeplacement]
      rollData.difficulte += __cibleCouvert[rollData.cibleCouvert]
      rollData.difficulte += __tailleCible[rollData.tailleCible]
      rollData.difficulte += rollData.cibleDeplace ? 3 : 0
      rollData.difficulte += rollData.cibleCaC ? 3 : 0
      rollData.difficulte += rollData.protectionDefenseur
    }
    if (rollData.attaqueDesarme) {
      rollData.difficulte += 10
    }

    // Ajout adversités
    rollData.diceFormula += `-${rollData.nbAdversites}`

    if (rollData.arme && rollData.arme.type == "arme") {
      rollData.diceFormula += `+${rollData.arme.system.bonusmaniementoff}`
    }

    // Gestion de la feinte éventuelle
    rollData.nbCombativitePerdu = 1

    let myRoll = await new Roll(rollData.diceFormula).roll()
    await this.showDiceSoNice(myRoll, game.settings.get("core", "rollMode"))
    rollData.roll = foundry.utils.duplicate(myRoll)
    console.log(">>>> ", myRoll)

    rollData.finalResult = myRoll.total
    this.computeResult(rollData)
    if (rollData.isInit) {
      actor.setFlag("world", "last-initiative", rollData.finalResult)
    }
    if (rollData.feinte) {
      actor.changeBonneAventure(-1)
      if (rollData.isHeroique) {
        rollData.nbCombativitePerdu = "vaincu"
      } else if (rollData.isSuccess) {
        rollData.nbCombativitePerdu = 2
      }
    }

    this.createChatWithRollMode(rollData.alias, {
      content: await foundry.applications.handlebars.renderTemplate(`systems/fvtt-mournblade-cyd2/templates/chat-generic-result.html`, rollData)
    }, rollData)

    if ((rollData.coupBas || rollData.arme) && rollData.isSuccess && rollData.defenderTokenId) {
      this.applyCombativite(rollData, rollData.nbCombativitePerdu)
    }
    if (rollData.coupBas && rollData.isSuccess && rollData.defenderTokenId) {
      let defender = game.canvas.tokens.get(rollData.defenderTokenId).actor
      defender.incDecAdversite("bleue", -2)
    }
  }

  /* -------------------------------------------- */
  static getCombativiteList(nbActivite) {
    let list = [{ value: String(0), label: "Combatif" }]
    for (let i = 1; i < nbActivite - 2; i++) {
      list.push({ value: String(i), label: "Eprouvé " + i })
    }
    list[nbActivite - 2] = { value: String(nbActivite - 2), label: "Affaibli" }
    list[nbActivite - 1] = { value: String(nbActivite - 1), label: "Très Affaibli" }
    list[nbActivite] = { value: String(nbActivite), label: "Vaincu" }
    return list
  }

  /* -------------------------------------------- */
  static async bonusRollMournbladeCYD2(rollData) {
    rollData.bonusFormula = rollData.addedBonus
    console.log("Bonus Roll MournbladeCYD2", rollData.bonusFormula)

    if (!Number(rollData.bonusFormula)) {
      let bonusRoll = await new Roll(rollData.bonusFormula).roll()
      await this.showDiceSoNice(bonusRoll, game.settings.get("core", "rollMode"));
      rollData.bonusRoll = foundry.utils.duplicate(bonusRoll)
      rollData.finalResult += Number(rollData.bonusRoll.total)
    } else {
      rollData.finalResult += Number(rollData.bonusFormula)
      console.log("Bonus Roll MournbladeCYD2 2", rollData.finalResult)
    }

    this.computeResultQuality(rollData)

    this.createChatWithRollMode(rollData.alias, {
      content: await foundry.applications.handlebars.renderTemplate(`systems/fvtt-mournblade-cyd2/templates/chat-generic-result.html`, rollData)
    }, rollData)

  }

  /* -------------------------------------------- */
  static getUsers(filter) {
    return game.users.filter(filter).map(user => user._id);
  }

  /* -------------------------------------------- */
  static getWhisperRecipients(rollMode, name) {
    switch (rollMode) {
      case "blindroll": return this.getUsers(user => user.isGM);
      case "gmroll": return this.getWhisperRecipientsAndGMs(name);
      case "selfroll": return [game.user.id];
    }
    return undefined;
  }
  /* -------------------------------------------- */
  static getWhisperRecipientsAndGMs(name) {
    let recep1 = ChatMessage.getWhisperRecipients(name) || [];
    return recep1.concat(ChatMessage.getWhisperRecipients('GM'));
  }

  /* -------------------------------------------- */
  static blindMessageToGM(chatOptions) {
    let chatGM = foundry.utils.duplicate(chatOptions);
    chatGM.whisper = this.getUsers(user => user.isGM);
    chatGM.content = "Blinde message of " + game.user.name + "<br>" + chatOptions.content;
    console.log("blindMessageToGM", chatGM);
    game.socket.emit("system.fvtt-mournblade-cyd2", { msg: "msg_gm_chat_message", data: chatGM });
  }

  /* -------------------------------------------- */
  static async searchItem(dataItem) {
    let item
    if (dataItem.pack) {
      let id = dataItem.id || dataItem._id
      let items = await this.loadCompendium(dataItem.pack, item => item.id == id)
      item = items[0] || undefined
    } else {
      item = game.items.get(dataItem.id)
    }
    return item
  }

  /* -------------------------------------------- */
  static split3Columns(data) {

    let array = [[], [], []];
    if (data == undefined) return array;

    let col = 0;
    for (let key in data) {
      let keyword = data[key];
      keyword.key = key; // Self-reference
      array[col].push(keyword);
      col++;
      if (col == 3) col = 0;
    }
    return array;
  }

  /* -------------------------------------------- */
  static async createChatMessage(name, rollMode, chatOptions, rollData = undefined) {
    switch (rollMode) {
      case "blindroll": // GM only
        if (!game.user.isGM) {
          this.blindMessageToGM(chatOptions);

          chatOptions.whisper = [game.user.id];
          chatOptions.content = "Message only to the GM";
        }
        else {
          chatOptions.whisper = this.getUsers(user => user.isGM);
        }
        break;
      default:
        chatOptions.whisper = this.getWhisperRecipients(rollMode, name);
        break;
    }
    chatOptions.alias = chatOptions.alias || name
    let msg = await ChatMessage.create(chatOptions)
    console.log("=======>", rollData)
    msg.setFlag("world", "mournblade-cyd2-roll", rollData)
  }

  /* -------------------------------------------- */
  static getBasicRollData() {
    let rollData = {
      rollId: foundry.utils.randomID(16),
      rollMode: game.settings.get("core", "rollMode"),
      modificateursOptions: this.getModificateurOptions(),
      pointAmeOptions: this.getPointAmeOptions(),
      difficulte: 0,
      modificateur: 0,
      bonusMalusContext: 0,
      bonusArmeNaturelle: 0,
      defenseurAveugle: false,
      defenseurDeDos: false,
      defenseurAuSol: false,
      defenseurRestreint: false,
      defenseurImmobilise: false,
      tailleCible: "normal",
      tireurDeplacement: "immobile",
      cibleCouvert: "aucun",
      distanceTir: "porteemoyenne",
      attaqueCharge: false,
      attaqueDesarme: false,
      attaqueAmbidextre1: false,
      attaqueAmbidextre2: false,
      chargeCavalerie: false,
      contenir: false,
      soutiens: 0
    }
    return rollData
  }

  /* -------------------------------------------- */
  static updateWithTarget(rollData) {
    let target = MournbladeCYD2Utility.getTarget()
    if (target) {
      rollData.defenderTokenId = target.id
      let defender = game.canvas.tokens.get(rollData.defenderTokenId).actor
      rollData.armeDefense = defender.getBestDefenseValue()
      rollData.armeAttaqueDefenseur = defender.getBestAttackValue()
      rollData.targetVigueur = defender.getVigueur()
      rollData.protectionDefenseur = defender.getProtection()
      if (rollData.immobiliser || rollData.repousser) {
        let combatValues = defender.getCombatValues()
        rollData.difficulte = combatValues.defenseTotal + (rollData.armeDefense && rollData.cibleconsciente ? 5 : 0)
      } else if (rollData.coupBas) {
        let combatValues = defender.getCombatValues()
        rollData.difficulte = combatValues.defenseTotal
      } else if (rollData.assomer) {
        rollData.difficulte = 3 + (defender.system.attributs.tre.value * 2)
      } else if (rollData.desengager) {
        rollData.difficulte = rollData.armeAttaqueDefenseur?.system?.totalOffensif || 0;
      } else if (rollData.armeDefense) {
        rollData.difficulte = rollData.armeDefense.system.totalDefensif
        if (!rollData.desengager && !rollData.arme.system.armenaturelle && !rollData.arme.system.armefortune) {
          if (rollData.armeDefense.system.armenaturelle || rollData.armeDefense.system.armefortune) {
            rollData.bonusArmeNaturelle = 3
          }
        }
      } else {
        ui.notifications.warn("Aucune arme de défense équipée, difficulté manuelle à positionner.")
      }
    }
  }

  /* -------------------------------------------- */
  static createChatWithRollMode(name, chatOptions, rollData = undefined) {
    this.createChatMessage(name, game.settings.get("core", "rollMode"), chatOptions, rollData)
  }

  /* -------------------------------------------- */
  static applyBonneAventureRoll(li, changed, addedBonus) {
    let msgId = $(li).data("message-id")
    let msg = game.messages.get(msgId)
    if (msg) {
      let rollData = msg.getFlag("world", "mournblade-cyd2-roll")
      let actor = MournbladeCYD2Utility.getActorFromRollData(rollData)
      actor.changeBonneAventure(changed)
      rollData.isReroll = true
      rollData.textBonus = "Bonus de Points d'Aventure"
      if (addedBonus == "reroll") {
        MournbladeCYD2Utility.rollMournbladeCYD2(rollData)
      } else {
        rollData.addedBonus = addedBonus
        MournbladeCYD2Utility.bonusRollMournbladeCYD2(rollData)
      }
    }
  }

  /* -------------------------------------------- */
  static applyEclatRoll(li, changed, addedBonus) {
    let msgId = $(li).data("message-id")
    let msg = game.messages.get(msgId)
    if (msg) {
      let rollData = msg.getFlag("world", "mournblade-cyd2-roll")
      let actor = MournbladeCYD2Utility.getActorFromRollData(rollData)
      actor.changeEclat(changed)
      rollData.isReroll = true
      rollData.textBonus = "Bonus d'Eclat"
      if (addedBonus == "reroll") {
        MournbladeCYD2Utility.rollMournbladeCYD2(rollData)
      } else {
        rollData.addedBonus = addedBonus
        MournbladeCYD2Utility.bonusRollMournbladeCYD2(rollData)
      }
    }
  }

  /* -------------------------------------------- */
  static chatRollMenu(html, options) {
    let canApply = li => canvas.tokens.controlled.length && li.find(".mournblade-cyd2-roll").length
    let canApplyBA = function (li) {
      let message = game.messages.get($(li).attr("data-message-id"))
      let rollData = message.getFlag("world", "mournblade-cyd2-roll")
      let actor = MournbladeCYD2Utility.getActorFromRollData(rollData)
      return (!rollData.isReroll && actor.getBonneAventure() > 0)
    }
    let canApplyPE = function (li) {
      let message = game.messages.get($(li).attr("data-message-id"))
      let rollData = message.getFlag("world", "mournblade-cyd2-roll")
      let actor = MournbladeCYD2Utility.getActorFromRollData(rollData)
      return (!rollData.isReroll && actor.getEclat() > 0)
    }
    options.push(
      {
        name: "Ajouer +3 (1 point de Bonne Aventure)",
        icon: "<i class='fas fa-user-plus'></i>",
        condition: canApply && canApplyBA,
        callback: li => MournbladeCYD2Utility.applyBonneAventureRoll(li, -1, "+3")
      }
    )
    options.push(
      {
        name: "Ajouter +10 (1 Point d'Eclat)",
        icon: "<i class='fas fa-user-plus'></i>",
        condition: canApply && canApplyPE,
        callback: li => MournbladeCYD2Utility.applyEclatRoll(li, -1, "+10")
      }
    )
    options.push(
      {
        name: "Relancer le dé (1 point d'Eclat)",
        icon: "<i class='fas fa-user-plus'></i>",
        condition: canApply && canApplyPE,
        callback: li => MournbladeCYD2Utility.applyEclatRoll(li, -1, "reroll")
      }
    )
    return options
  }

  /* -------------------------------------------- */
  static async confirmDelete(actorSheet, li) {
    let itemId = li.data("item-id");
    let msgTxt = "<p>Etes vous certain de vouloir supprimer cet item ?";
    let buttons = {
      delete: {
        icon: '<i class="fas fa-check"></i>',
        label: "Oui !",
        callback: () => {
          actorSheet.actor.deleteEmbeddedDocuments("Item", [itemId]);
          li.slideUp(200, () => actorSheet.render(false));
        }
      },
      cancel: {
        icon: '<i class="fas fa-times"></i>',
        label: "Non"
      }
    }
    msgTxt += "</p>";
    let d = new Dialog({
      title: "Confirmer la suppression",
      content: msgTxt,
      buttons: buttons,
      default: "cancel"
    });
    d.render(true);
  }

  /************************************************************************************/
  static async __create_talents_table() {
    let compName = "fvtt-mournblade-cyd2.talents-cellule"
    const compData = await MournbladeCYD2Utility.loadCompendium(compName)
    let talents = compData.map(i => i.toObject())

    let htmlTab = "<table border='1'><tbody>";
    for (let entryData of talents) {
      console.log(entryData)
      htmlTab += `<tr><td>@UUID[Compendium.${compName}.${entryData._id}]{${entryData.name}}</td>`
      htmlTab += `<td>${entryData.system.description}</td>`;
      htmlTab += "</tr>\n";
    }
    htmlTab += "</table>";
    await JournalEntry.create({ name: 'Liste des Talents de Cellule', content: htmlTab });
  }
}
